#!BPY
""" Registration info for Blender menus
Name: 'ph_Cool_FILL_V1_5'
Blender: 232
Group: 'Misc'
"""


###########################################
#                                         #
#           ph_Cool_FILL_V1_5.py          #
#                                         #
#  Ma fonction 'FILL' revue et corrigee.  #
#                                         #
#  Cree le 26/12/2003                     #
#                                         #
#  par coolphil@worldonline.fr            #
#                                         #
###########################################

############## USAGE ##########################
#
# La fonction 'Extrude' de Blender ne prenant pas
# en compte les weights groups, j'ai donc fait ce script
# pour contourner ce defaut.
#
# Explication :
# Faite comme pour un 'Extrude' normal, c'est a dire,
# selectionnez vos faces a extruder mais au lieu d'appeler
# la fonction 'Extrude', faite 'Split' a la place.
# Faite ensuite 'Alt-S' comme vous l'auriez fait avec 
# la fonction 'Extrude'.
# On constate bien evidemment qu'il manque les Faces du
# contour, mais par contre nos weights groups sont preserves.
#
# C'est la que mon script entre en scene :
# Blender a deux fonction 'Fill' et 'Beauty Fill'
# qui pourraint remplir les faces manquantes,
# mais elles 'Triplent' les nouvelles faces crees
# et donnent parfois des resultats surprenant.
#
# J'ai donc decide de recree ma propre fonction 'Fill'
# qui rempli les faces manquantes comme l'aurait fait
# la fonction 'Extrude'.
#
#                    ########
#
# Donc comme dit plus haut, apres avoir fait 'Split'
# et 'Alt-S', lancer le script (Alt-P) et appuyer sur
# le bouton 'Get selected' qui va creer deux groups.
# Ensuite selectionnez juste les deux premiers points
# que devrait contenir la 1ere face a cree (1 point sur
# chacune des deux partie distincts, sur leurs bordure)
# et les assigner au group 'SelectedVerts'.
# Repasser en mode 'objet' et appuyer sur 'Make cool FILL'.
# Le script va combler les faces manquantes.
# Il se peut que les faces crees ne soit pas dans le bon sens,
# dans ce cas appuyez sur le bouton 'Reverse filled'.
# 
# Pour les gros 'Mesh' (qui ont beaucoups de vertices), les calculs
# peuvent etre assez long (a cause du dictionnaire 'listFacesfromVert'
# cree en debut de script).
# C'est pourquoi j'ai rajoute un bouton 'Selected faces' pour ne
# travailler que sur les faces selectionnees MAIS ATTENTION
# ASSURER VOUS DE BIEN SELECTIONNER AU MOINS TOUTES LES FACES
# QUI SONT TOUT AUTOUR DES DEUX 'BORDURES' A JOINDRE (sinon risque
# de plantage du sript).
#
#
# A l'aide de ce script et de mon autre script 'ph_CleanWeight_V1_1.py',
# vous n'aurez plus de difficultes a modifier un Mesh deja 'skinne'.
#
#######################################################################


import Blender
from Blender import *
from Blender.Draw import *
from Blender.BGL import *
import math

first_time = 0


Obj = []
mesh = []

WitchFill = 0

DeuxPointsSel = []

listPointsFromP1 = []
listPointsFromP2 = []
CloseEdgesl1 = []

SelFtoggle =Create(0)


#############################
def DicoFacesfromVert(me):  #
#############################
  global listFacesfromVert, SelFtoggle

  listFacesfromVert = {}
  for x in range(len(me.verts)):
      listFacesfromVert[x] = []

  if SelFtoggle.val == 1:
      MeshFaces = me.getSelectedFaces()
  else:
      MeshFaces = me.faces


  for f in MeshFaces:
     Findx = me.faces.index(f)

     for v in f.v:

        if Findx not in listFacesfromVert[v.index]:

            listFacesfromVert[v.index].append(Findx)


  return


##############
def trie():  #
##############
  global Obj, meshname, mesh, listFacesfromVert


  Obj = Object.GetSelected()[0]

  print "Obj =", Obj
  if (Obj != []):
    if (Obj.getType() == 'Mesh'):
      calque = Obj.Layer                    # Le "layer" de l'object selectionne
      meshname = Obj.getData().name
      mesh = Obj.getData()


      print "Maintenant je calcule listFacesfromVert"; print

      DicoFacesfromVert(mesh)

      print "OK, done."
#      print "Les faces attribues aux vertices"
#      print listFacesfromVert
#      print

      return 1

  return 0


#########################
def shared1Faces(p1,p2):#
#########################
    global listFacesfromVert

    listFs = []

    lFfVTemp = listFacesfromVert[p1]
    for f in lFfVTemp:
        listFs.append(f)

    lFfVTemp = listFacesfromVert[p2]
    for f in lFfVTemp:
        listFs.append(f)

    listFs.sort()
#    print "listFs =", listFs

    ##### on fait la liste des faces communes #####

    listSelectDouble = []
    lenlist = len(listFs)
    compt = 0

    while compt != lenlist:
        if listFs.count(listFs[compt]) == 2:

                listSelectDouble.append(listFs[compt])
                compt += 1
        compt += 1

#    print "listSelectDouble =", listSelectDouble

    if len(listSelectDouble) > 1:
        return 0
    else:
        return 1


#########################
def findHole(Point, me):#
#########################
    global listFacesfromVert

    listEdgesFromPoint = []
    listEdgesFromPoint.append(Point)

    fini = 0
    CloseEdges = 1

    while fini == 0:
        Px = listEdgesFromPoint[-1]
#        print "Px =",Px

        if len(listEdgesFromPoint) > 1:
            Px_2 = listEdgesFromPoint[-2]
#            print "Px_2 =",Px_2

        sesFaces = listFacesfromVert[Px]
#        print "sesFaces du point %s = %s" %(Point, sesFaces)

        EdgeOrNot = 0
        comptFace_no = 1

        for fx in sesFaces:
            Fv = []
            for v in me.faces[fx].v:            ##### On fait la liste des points de la face #####
                Fv.append(me.verts.index(v))
#            print "Point%s, face%s, F.v =%s" %(Px, fx, Fv)

            placePx = Fv.index(Px)
            newP = []
            ############################################################################################
            if len(listEdgesFromPoint) == 1 and EdgeOrNot == 0:  #### ici on est au debut (1er point) ####

                ############### POLYGONE A 4 POINTS #######################
                if len(Fv) == 4:
                    ####### on essaye avec son suivant donc on essaye le sens de direction (newP = Fv[placePx + 1]) ######
                    if placePx > -1 and placePx < 3:
                        newP = Fv[placePx + 1]
                        EdgeOrNot = shared1Faces(Px,newP)     ###### On test si on est sur une bordure ######

                        if EdgeOrNot ==1:      ###### EdgeOrNot = 1 ######
                            listEdgesFromPoint.append(newP)   ###### nouveau point trouve #####


                    if placePx == 3 and EdgeOrNot == 0:
                        newP = Fv[0]
                        EdgeOrNot = shared1Faces(Px,newP)     ###### On test si on est sur une bordure ######

                        if EdgeOrNot ==1:      ###### EdgeOrNot = 1 ######
                            listEdgesFromPoint.append(newP)   ###### nouveau point trouve #####



                    ####### on essaye avec son precedent donc on essaye le sens de direction (newP = Fv[placePx - 1] ######
                    if placePx == 0 and EdgeOrNot == 0:
                        newP = Fv[3]
                        EdgeOrNot = shared1Faces(Px,newP)     ###### On test si on est sur une bordure ######

                        if EdgeOrNot ==1:      ###### EdgeOrNot = 1 ######
                            listEdgesFromPoint.append(newP)   ###### nouveau point trouve #####


                    if placePx > 0 and placePx < 4 and EdgeOrNot == 0:
                        newP = Fv[placePx - 1]
                        EdgeOrNot = shared1Faces(Px,newP)     ###### On test si on est sur une bordure ######

                        if EdgeOrNot ==1:      ###### EdgeOrNot = 1 ######
                            listEdgesFromPoint.append(newP)   ###### nouveau point trouve #####


                ############### POLYGONE A 3 POINTS #######################
                elif len(Fv) == 3:
                    ####### on essaye avec son suivant donc on essaye le sens de direction (newP = Fv[placePx + 1]) ######
                    if placePx > -1 and placePx < 2:
                        newP = Fv[placePx + 1]
                        EdgeOrNot = shared1Faces(Px,newP)     ###### On test si on est sur une bordure ######

                        if EdgeOrNot ==1:      ###### EdgeOrNot = 1 ######
                            listEdgesFromPoint.append(newP)   ###### nouveau point trouve #####

                    if placePx == 2 and EdgeOrNot == 0:
                        newP = Fv[0]
                        EdgeOrNot = shared1Faces(Px,newP)     ###### On test si on est sur une bordure ######

                        if EdgeOrNot ==1:      ###### EdgeOrNot = 1 ######
                            listEdgesFromPoint.append(newP)   ###### nouveau point trouve #####

                    ####### on essaye avec son precedent donc on essaye le sens de direction (newP = Fv[placePx - 1] ######
                    if placePx == 0 and EdgeOrNot == 0:
                        newP = Fv[2]
                        EdgeOrNot = shared1Faces(Px,newP)     ###### On test si on est sur une bordure ######

                        if EdgeOrNot ==1:      ###### EdgeOrNot = 1 ######
                            listEdgesFromPoint.append(newP)   ###### nouveau point trouve #####

                    if placePx > 0 and placePx < 3 and EdgeOrNot == 0:
                        newP = Fv[placePx - 1]
                        EdgeOrNot = shared1Faces(Px,newP)     ###### On test si on est sur une bordure ######

                        if EdgeOrNot ==1:      ###### EdgeOrNot = 1 ######
                            listEdgesFromPoint.append(newP)   ###### nouveau point trouve #####

                ############### POLYGONE A 2 POINTS #######################
                elif len(Fv) == 2:
                    ####### on prend donc forcement son suivant  ######
                    if placePx == 0:
                        newP = Fv[1]
                        EdgeOrNot = 1
                        listEdgesFromPoint.append(newP)   ###### nouveau point trouve #####

                    if placePx == 1 and EdgeOrNot == 0:
                        newP = Fv[0]
                        EdgeOrNot = 1
                        listEdgesFromPoint.append(newP)   ###### nouveau point trouve #####





            ############################################################################################
            elif len(listEdgesFromPoint) > 1 and EdgeOrNot == 0:  #### ici on est plus au debut ####

                ############### POLYGONE A 4 POINTS #######################
                if len(Fv) == 4:
                    ####### on essaye avec son suivant donc on essaye le sens de direction (newP = Fv[placePx + 1]) ######
                    if placePx > -1 and placePx < 3:
                        newP = Fv[placePx + 1]
                        if newP != Px_2:
                            EdgeOrNot = shared1Faces(Px,newP)     ###### On test si on est sur une bordure ######

                            if EdgeOrNot ==1:      ###### EdgeOrNot = 1 ######
                                if newP != Point:
                                    listEdgesFromPoint.append(newP)   ###### nouveau point trouve #####
                                else:
                                    fini = 1

                    if placePx == 3 and EdgeOrNot == 0:
                        newP = Fv[0]
                        if newP != Px_2:
                            EdgeOrNot = shared1Faces(Px,newP)     ###### On test si on est sur une bordure ######

                            if EdgeOrNot ==1:      ###### EdgeOrNot = 1 ######
                                if newP != Point:
                                    listEdgesFromPoint.append(newP)   ###### nouveau point trouve #####
                                else:
                                    fini = 1


                    ####### on essaye avec son precedent donc on essaye le sens de direction (newP = Fv[placePx - 1] ######
                    if placePx == 0 and EdgeOrNot == 0:
                        newP = Fv[3]
                        if newP != Px_2:
                            EdgeOrNot = shared1Faces(Px,newP)     ###### On test si on est sur une bordure ######

                            if EdgeOrNot ==1:      ###### EdgeOrNot = 1 ######
                                if newP != Point:
                                    listEdgesFromPoint.append(newP)   ###### nouveau point trouve #####
                                else:
                                    fini = 1

                    if placePx > 0 and placePx < 4 and EdgeOrNot == 0:
                        newP = Fv[placePx - 1]
                        if newP != Px_2:
                            EdgeOrNot = shared1Faces(Px,newP)     ###### On test si on est sur une bordure ######

                            if EdgeOrNot ==1:      ###### EdgeOrNot = 1 ######
                                if newP != Point:
                                    listEdgesFromPoint.append(newP)   ###### nouveau point trouve #####
                                else:
                                    fini = 1



                ############### POLYGONE A 3 POINTS #######################
                elif len(Fv) == 3:
                    ####### on essaye avec son suivant donc on essaye le sens de direction (newP = Fv[placePx + 1]) ######
                    if placePx > -1 and placePx < 2:
                        newP = Fv[placePx + 1]
                        if newP != Px_2:
                            EdgeOrNot = shared1Faces(Px,newP)     ###### On test si on est sur une bordure ######

                            if EdgeOrNot ==1:      ###### EdgeOrNot = 1 ######
                                if newP != Point:
                                    listEdgesFromPoint.append(newP)   ###### nouveau point trouve #####
                                else:
                                    fini = 1


                    if placePx == 2 and EdgeOrNot == 0:
                        newP = Fv[0]
                        if newP != Px_2:
                            EdgeOrNot = shared1Faces(Px,newP)     ###### On test si on est sur une bordure ######

                            if EdgeOrNot ==1:      ###### EdgeOrNot = 1 ######
                                if newP != Point:
                                    listEdgesFromPoint.append(newP)   ###### nouveau point trouve #####
                                else:
                                    fini = 1


                    ####### on essaye avec son precedent donc on essaye le sens de direction (newP = Fv[placePx - 1] ######
                    if placePx == 0 and EdgeOrNot == 0:
                        newP = Fv[2]
                        if newP != Px_2:
                            EdgeOrNot = shared1Faces(Px,newP)     ###### On test si on est sur une bordure ######

                            if EdgeOrNot ==1:      ###### EdgeOrNot = 1 ######
                                if newP != Point:
                                    listEdgesFromPoint.append(newP)   ###### nouveau point trouve #####
                                else:
                                    fini = 1


                    if placePx > 0 and placePx < 3 and EdgeOrNot == 0:
                        newP = Fv[placePx - 1]
                        if newP != Px_2:
                            EdgeOrNot = shared1Faces(Px,newP)     ###### On test si on est sur une bordure ######

                            if EdgeOrNot ==1:      ###### EdgeOrNot = 1 ######
                                if newP != Point:
                                    listEdgesFromPoint.append(newP)   ###### nouveau point trouve #####
                                else:
                                    fini = 1


                ############### POLYGONE A 2 POINTS #######################
                elif len(Fv) == 2:
                    ####### on prend donc forcement son suivant  ######
                    if placePx == 0 and EdgeOrNot == 0:
                        newP = Fv[1]
                        if newP != Px_2 and newP != Point:
                            EdgeOrNot = 1
                            listEdgesFromPoint.append(newP)   ###### nouveau point trouve #####

                        else:
                            if len(sesFaces) == 1 and newP == Px_2:
                                fini = 1
                                CloseEdges = 0

                            elif len(sesFaces) > 1 and comptFace_no > 1 and newP == Point:
                                fini = 1



                    if placePx == 1 and EdgeOrNot == 0:
                        newP = Fv[0]
                        if newP != Px_2 and newP != Point:
                            EdgeOrNot = 1
                            listEdgesFromPoint.append(newP)   ###### nouveau point trouve #####

                        else:
                            if len(sesFaces) == 1 and newP == Px_2:
                                fini = 1
                                CloseEdges = 0

                            elif len(sesFaces) > 1 and comptFace_no > 1 and newP == Point:
                                fini = 1


            comptFace_no += 1

            if EdgeOrNot ==1:
                break

        if EdgeOrNot ==0:
            fini = 1

#    print "1:comptFace_no = ", comptFace_no
#    print "1:CloseEdges = ", CloseEdges
    return listEdgesFromPoint, CloseEdges

##########################
def getSelectedVerts(me):#
##########################

	theSelVerts = []
	for v in me.verts:
		if v.sel:
			theSelVerts.append(v.index)
			if len(theSelVerts) > 2 :
				theSelVerts = []; return theSelVerts

	return theSelVerts


################
def MakeFill():#
################
    global mesh, Obj, calque, DeuxPointsSel
    global listFacesfromVert, meshname, me1
    global listPointsFromP1, listPointsFromP2, CloseEdgesl1


    DeuxPointsSel = []    #### Les deux points du group 'SelectedVerts' ####


    ############## Recuperation des deux points du group 'SelectedVerts' ##############

    DeuxPointsSel = getSelectedVerts(mesh)

    if len(DeuxPointsSel) == 2:
      Point1 = DeuxPointsSel[0]
      Point2 = DeuxPointsSel[1]

      listPointsFromP1, CloseEdgesl1 = findHole(Point1, mesh)
      listPointsFromP2, CloseEdgesl2 = findHole(Point2, mesh)
#        print "listPointsFromP1 =", listPointsFromP1
#        print "listPointsFromP2 =", listPointsFromP2

#################################
      if (CloseEdgesl1 and CloseEdgesl2) or (CloseEdgesl1==0 and CloseEdgesl2==0):
#       print "CloseEdgesl1=",CloseEdgesl1," CloseEdgesl2=",CloseEdgesl2

       if len(listPointsFromP2) > len(listPointsFromP1):
        tp = listPointsFromP2
        listPointsFromP2 = listPointsFromP1
        listPointsFromP1 = tp

        Fill2(listPointsFromP1, listPointsFromP2, CloseEdgesl1)

       else:

        Fill2(listPointsFromP1, listPointsFromP2, CloseEdgesl1)

#################################
      else:
        if len(listPointsFromP1) == len(listPointsFromP2):
            if CloseEdgesl2 == 0:
                tp = listPointsFromP2
                listPointsFromP2 = listPointsFromP1
                listPointsFromP1 = tp

                CloseEdgesl2 = CloseEdgesl1
                CloseEdgesl1 = 0


            Fill(listPointsFromP1, listPointsFromP2, CloseEdgesl1)

        else:

            if len(listPointsFromP1) > len(listPointsFromP2) and CloseEdgesl2 == 0:
                tp = listPointsFromP2
                listPointsFromP2 = listPointsFromP1
                listPointsFromP1 = tp

                tp = CloseEdgesl2
                CloseEdgesl2 = CloseEdgesl1
                CloseEdgesl1 = tp

                Fill(listPointsFromP1, listPointsFromP2, CloseEdgesl1)

            elif len(listPointsFromP2) > len(listPointsFromP1) and CloseEdgesl1 == 0:

                Fill(listPointsFromP1, listPointsFromP2, CloseEdgesl1)

            

    return

###############################
def Fill(list1, list2, ClEdg):#
###############################
    global Obj, mesh

    for v in range(len(list1)-1):
        Fce = NMesh.Face()

        Fce.v.append(mesh.verts[list1[v]])
        Fce.v.append(mesh.verts[list2[v]])
        Fce.v.append(mesh.verts[list2[v+1]])
        Fce.v.append(mesh.verts[list1[v+1]])

        mesh.faces.append(Fce)


#    print "2:ClEdg = ", ClEdg
    if ClEdg == 1:
        Fce = NMesh.Face()

        Fce.v.append(mesh.verts[list1[-1]])
        Fce.v.append(mesh.verts[list2[-1]])
        Fce.v.append(mesh.verts[list2[0]])
        Fce.v.append(mesh.verts[list1[0]])

        mesh.faces.append(Fce)

    NMesh.PutRaw(mesh, meshname, 1)
    Obj.makeDisplayList()

    return

#########################
def Fill2(list1, list2, ClEdg):#
#########################
    global Obj, mesh, WitchFill

    WitchFill = 1

#    print "len list1= ",len(list1), " len(list2)= ",len(list2)
    fact = float(len(list2))/float(len(list1))
#    print "facteur =",fact

    for v in range(len(list1)-1):
        Fce = NMesh.Face()

        fl = v * 1.0

        Fce.v.append(mesh.verts[list1[v]])

        pp1 = int(fl*fact)
#        print "pp1= ",pp1
        Fce.v.append(mesh.verts[list2[pp1]])
        pp2 = int((fl+1)*fact)
#        print "pp2= ",pp2
        if pp2 != pp1:
            Fce.v.append(mesh.verts[list2[pp2]])
        Fce.v.append(mesh.verts[list1[v+1]])

        mesh.faces.append(Fce)

    if ClEdg:

        Fce = NMesh.Face()

        Fce.v.append(mesh.verts[list1[-1]])
        Fce.v.append(mesh.verts[list2[-1]])
        Fce.v.append(mesh.verts[list2[0]])
        Fce.v.append(mesh.verts[list1[0]])

        mesh.faces.append(Fce)

    NMesh.PutRaw(mesh, meshname, 1)
    Obj.makeDisplayList()

    return

#####################
def ReverseFilled():#
#####################
        global listPointsFromP1, listPointsFromP2, CloseEdgesl1, mesh, WitchFill


#        print "listPointsFromP1 =", listPointsFromP1
        ###### On reverse listPointsFromP2 ######
#        print "listPointsFromP2 =", listPointsFromP2
        rev = listPointsFromP2[1:]
        rev.reverse()
        rev.insert(0, listPointsFromP2[0])
#        print "reversed =", rev
        listPointsFromP2 = rev

        if CloseEdgesl1 == 0:
            nbFacesToDel = len(listPointsFromP1) - 1
        else:
            nbFacesToDel = len(listPointsFromP1)
#        print "nbFacesToDel =", nbFacesToDel

        ###### On Delete les faces ######
        for f in range(nbFacesToDel):
            del  mesh.faces[-1]

        ###### On recree les faces ######
        if WitchFill:
            Fill2(listPointsFromP1, listPointsFromP2, CloseEdgesl1)
        else:
            Fill(listPointsFromP1, listPointsFromP2, CloseEdgesl1)

        return




#################
def main():     #
#################
  global  Obj, first_time, mesh, meshname, calque

  first_time = 1

  Obj = Object.GetSelected()[0]

  print "Obj =", Obj
  if (Obj != []):
    if (Obj.getType() == 'Mesh'):
      calque = Obj.Layer                    # Le "layer" de l'object selectionne
      meshname = Obj.getData().name
      mesh = Obj.getData()
      return 1

  return 0


############
def draw():#
############
  global SelFtoggle

  color1 = (0.99, 0.99, 0.65)
  color2 = (0.567, 0.476, 0.365)
  color2Clear = (0.567, 0.476, 0.365, 1)
  color3 = (1.0, 1.0, 0.79)
  color4 = (0.265, 0.41, 0.4)
  color4Clear = (0.265, 0.41, 0.4, 1)
  color5 = (0.4, 0.472, 0.472)
  color6 = (0.5, 0.25, 0.25)
  color7 = (0.265, 0.4, 0.3)
  colorblack = (0.0, 0.0, 0.0)
  colorwhite = (1.0, 1.0, 1.0)
  colorred = (1.0, 0.0, 0.0)
  colorcyan = (0.0, 1.0, 1.0)
  colorgrey1 = (0.8, 0.8, 0.8)


  apply(glClearColor, color4Clear)

  glClear(GL_COLOR_BUFFER_BIT)

  apply(glColor3f, colorblack)
  glRecti(1, 1, 260, 140)
  apply(glColor3f, colorgrey1)
  glRecti(1, 1, 259, 141)
  apply(glColor3f, color7)
  glRecti(1, 1, 259, 140)

  apply(glColor3f, colorblack)
  glRecti(1, 104, 259, 140)
  glColor3f(0.265, 0.35, 0.3)
  glRecti(1, 105, 259, 140)



  apply(glColor3f, colorblack)
  glRecti(1, 136, 150, 108)
  apply(glColor3f, colorgrey1)
  glRecti(1, 136, 149, 110)
  apply(glColor3f, color6)
  glRecti(1, 135, 149, 109)


  apply(glColor3f, colorwhite)
  glRasterPos2f(10, 120)
  Text("ph_Cool_FILL_V1_5.py")


  Button("Exit", 1, 210, 112, 40, 23, "Quit")

  Button("Get selected", 2, 10, 65, 85, 25, "Get selected object to work on it.")

  SelFtoggle = Toggle("Selected faces", 5, 165, 65, 85, 25, SelFtoggle.val, "Work only with selected faces.")

  Button("Make cool FILL", 3, 10, 13, 110, 35,"Fill opened edges.")

  Button("Reverse filled", 4, 140, 13, 110, 35,"Reverse newly created faces.")



######################
def event(evt, val): #
######################

    if ( evt == ESCKEY and not val): Exit()
    if (evt== QKEY and not val): Exit()



######################
def bevent(evt):     #
######################
    global Obj, mesh, first_time, ListGroup, WitchFill
    global listPointsFromP1, listPointsFromP2

    if (evt== 1):
        Exit()

    if (evt== 2):
        print "Geting selected object."
        tp = main()


    if (evt== 3):
        if first_time != 0:     ###### WARNING #######

            Draw()
            tp = trie()
            if tp == 1:

                MakeFill()


            Blender.Window.Redraw()

    if (evt== 4):
        if listPointsFromP1 and listPointsFromP2:
            ReverseFilled()

    Blender.Window.Redraw()

############

Register(draw, event, bevent)
